({
  extendsFrom: 'bwc',

  initialize: function(options) {
    this._super('initialize', [options]);
  },

  loadIframe:function(){
    $.ajax({
      sugar_module: this.options.context.parent.attributes.module,
      sugar_record: this.options.context.parent.attributes.modelId,
      inbox_25_url: App.user.get('inbox25_url'),
      url: "index.php?entryPoint=inbox25_url",
      success: function(result) {
        if(this.inbox_25_url != 'https://www.inbox25.com/timelinefail.php') {
          this.inbox_25_url += (this.sugar_module == 'Opportunities') ? '&sugar_id_opp=' : '&sugar_id=';
          this.inbox_25_url += this.sugar_record;
          this.inbox_25_url += result;
        }
        $('#inbox25_url').attr('src', this.inbox_25_url);
        $('#inbox25_url').attr('width', '100%');
      },
      error: function(result) {
        app.alert.show('inboxview_error', {
          level: 'error',
          autoClose: false,
          messages: 'Unable to load Inbox25 Frame',
        });
      }
    });
  }

})
